diff --git a/src/mongo/db/matcher/schema/expression_internal_schema_fmod_test.cpp b/src/mongo/db/matcher/schema/expression_internal_schema_fmod_test.cpp
index 1701f0b8e2..9b1c256436 100644
--- a/src/mongo/db/matcher/schema/expression_internal_schema_fmod_test.cpp
+++ b/src/mongo/db/matcher/schema/expression_internal_schema_fmod_test.cpp
@@ -87,15 +87,15 @@ TEST(InternalSchemaFmodMatchExpression, NegativeRemainders) {
 
 TEST(InternalSchemaFmodMatchExpression, ElemMatchKey) {
     InternalSchemaFmodMatchExpression fmod("a", Decimal128(5), Decimal128(2));
-    MatchDetails details;
-    details.requestElemMatchKey();
+    ArrayPositionalMatch details;
+    details.requestArrayPosition();
     ASSERT_FALSE(fmod.matchesBSON(BSON("a" << 4), &details));
-    ASSERT_FALSE(details.hasElemMatchKey());
+    ASSERT_FALSE(details.arrayPosition());
     ASSERT_TRUE(fmod.matchesBSON(BSON("a" << 2), &details));
-    ASSERT_FALSE(details.hasElemMatchKey());
+    ASSERT_FALSE(details.arrayPosition());
     ASSERT_TRUE(fmod.matchesBSON(BSON("a" << BSON_ARRAY(1 << 2 << 5)), &details));
-    ASSERT_TRUE(details.hasElemMatchKey());
-    ASSERT_EQUALS("1", details.elemMatchKey());
+    ASSERT_TRUE(details.arrayPosition());
+    ASSERT_EQUALS("1", *details.arrayPosition());
 }
 
 TEST(InternalSchemaFmodMatchExpression, Equality) {
diff --git a/src/mongo/db/matcher/schema/expression_internal_schema_match_array_index.h b/src/mongo/db/matcher/schema/expression_internal_schema_match_array_index.h
index dea8895c86..e8d31018b2 100644
--- a/src/mongo/db/matcher/schema/expression_internal_schema_match_array_index.h
+++ b/src/mongo/db/matcher/schema/expression_internal_schema_match_array_index.h
@@ -52,7 +52,9 @@ public:
      * Matches 'array' if the element at '_index' matches '_expression', or if its size is less than
      * '_index'.
      */
-    bool matchesArray(const BSONObj& array, MatchDetails* details) const final {
+    bool matchesArray(const BSONObj& array,
+                      ArrayPositionalMatch* details,
+                      std::deque<std::string>* explain) const final {
         BSONElement element;
         auto iterator = BSONObjIterator(array);
 
@@ -64,7 +66,12 @@ public:
             element = iterator.next();
         }
 
-        return _expression->matchesBSONElement(element, details);
+        bool match = _expression->matchesBSONElement(element, details);
+        if (!match && explain) {
+            explain->push_front(str::stream() << "element " << _index << " of array '" << path()
+                                              << "' does not match: ");
+        }
+        return match;
     }
 
     void serialize(BSONObjBuilder* builder) const final;
diff --git a/src/mongo/db/matcher/schema/expression_internal_schema_max_items.h b/src/mongo/db/matcher/schema/expression_internal_schema_max_items.h
index 814aba1da8..977205fa67 100644
--- a/src/mongo/db/matcher/schema/expression_internal_schema_max_items.h
+++ b/src/mongo/db/matcher/schema/expression_internal_schema_max_items.h
@@ -43,8 +43,17 @@ public:
         : InternalSchemaNumArrayItemsMatchExpression(
               INTERNAL_SCHEMA_MAX_ITEMS, path, numItems, "$_internalSchemaMaxItems"_sd) {}
 
-    bool matchesArray(const BSONObj& anArray, MatchDetails* details) const final {
-        return (anArray.nFields() <= numItems());
+    bool matchesArray(const BSONObj& anArray,
+                      ArrayPositionalMatch* details,
+                      std::deque<std::string>* explain) const final {
+        bool match = (anArray.nFields() <= numItems());
+        if (!match && explain) {
+            explain->push_front(str::stream() << "array '" << path() << "' has "
+                                              << anArray.nFields()
+                                              << " elements, over the limit of "
+                                              << numItems());
+        }
+        return match;
     }
 
     std::unique_ptr<MatchExpression> shallowClone() const final {
diff --git a/src/mongo/db/matcher/schema/expression_internal_schema_max_properties.h b/src/mongo/db/matcher/schema/expression_internal_schema_max_properties.h
index 82bc65dabe..967db0f0f8 100644
--- a/src/mongo/db/matcher/schema/expression_internal_schema_max_properties.h
+++ b/src/mongo/db/matcher/schema/expression_internal_schema_max_properties.h
@@ -44,13 +44,16 @@ public:
                                                      numProperties,
                                                      "$_internalSchemaMaxProperties") {}
 
-    bool matches(const MatchableDocument* doc, MatchDetails* details) const final {
+    bool matches(const MatchableDocument* doc,
+                 ArrayPositionalMatch* details,
+                 std::deque<std::string>* explain) const final {
         BSONObj obj = doc->toBSON();
         return (obj.nFields() <= numProperties());
     }
 
     bool matchesSingleElement(const BSONElement& elem,
-                              MatchDetails* details = nullptr) const final {
+                              ArrayPositionalMatch* details = nullptr,
+                              std::deque<std::string>* explain = nullptr) const final {
         if (elem.type() != BSONType::Object) {
             return false;
         }
diff --git a/src/mongo/db/matcher/schema/expression_internal_schema_min_items.h b/src/mongo/db/matcher/schema/expression_internal_schema_min_items.h
index 3aaffb6234..2ae014058d 100644
--- a/src/mongo/db/matcher/schema/expression_internal_schema_min_items.h
+++ b/src/mongo/db/matcher/schema/expression_internal_schema_min_items.h
@@ -43,7 +43,9 @@ public:
         : InternalSchemaNumArrayItemsMatchExpression(
               INTERNAL_SCHEMA_MIN_ITEMS, path, numItems, "$_internalSchemaMinItems"_sd) {}
 
-    bool matchesArray(const BSONObj& anArray, MatchDetails* details) const final {
+    bool matchesArray(const BSONObj& anArray,
+                      ArrayPositionalMatch* details,
+                      std::deque<std::string>* explain) const final {
         return (anArray.nFields() >= numItems());
     }
 
diff --git a/src/mongo/db/matcher/schema/expression_internal_schema_min_properties.h b/src/mongo/db/matcher/schema/expression_internal_schema_min_properties.h
index 9ac68da48a..8c48b0e279 100644
--- a/src/mongo/db/matcher/schema/expression_internal_schema_min_properties.h
+++ b/src/mongo/db/matcher/schema/expression_internal_schema_min_properties.h
@@ -44,13 +44,16 @@ public:
                                                      numProperties,
                                                      "$_internalSchemaMinProperties") {}
 
-    bool matches(const MatchableDocument* doc, MatchDetails* details) const final {
+    bool matches(const MatchableDocument* doc,
+                 ArrayPositionalMatch* details,
+                 std::deque<std::string>* explain) const final {
         BSONObj obj = doc->toBSON();
         return (obj.nFields() >= numProperties());
     }
 
     bool matchesSingleElement(const BSONElement& elem,
-                              MatchDetails* details = nullptr) const final {
+                              ArrayPositionalMatch* details = nullptr,
+                              std::deque<std::string>* explain = nullptr) const final {
         if (elem.type() != BSONType::Object) {
             return false;
         }
diff --git a/src/mongo/db/matcher/schema/expression_internal_schema_object_match.cpp b/src/mongo/db/matcher/schema/expression_internal_schema_object_match.cpp
index b1a3301ff7..72bb85bc7b 100644
--- a/src/mongo/db/matcher/schema/expression_internal_schema_object_match.cpp
+++ b/src/mongo/db/matcher/schema/expression_internal_schema_object_match.cpp
@@ -42,12 +42,17 @@ InternalSchemaObjectMatchExpression::InternalSchemaObjectMatchExpression(
                           ElementPath::NonLeafArrayBehavior::kTraverse),
       _sub(std::move(expr)) {}
 
-bool InternalSchemaObjectMatchExpression::matchesSingleElement(const BSONElement& elem,
-                                                               MatchDetails* details) const {
+bool InternalSchemaObjectMatchExpression::matchesSingleElement(
+    const BSONElement& elem,
+    ArrayPositionalMatch* details,
+    std::deque<std::string>* explain) const {
     if (elem.type() != BSONType::Object) {
+        if (explain) {
+            explain->push_front(str::stream() << "'" << path() << "' is not an object");
+        }
         return false;
     }
-    return _sub->matchesBSON(elem.Obj());
+    return _sub->matchesBSON(elem.embeddedObject(), details, explain);
 }
 
 void InternalSchemaObjectMatchExpression::debugString(StringBuilder& debug, int level) const {
diff --git a/src/mongo/db/matcher/schema/expression_internal_schema_object_match.h b/src/mongo/db/matcher/schema/expression_internal_schema_object_match.h
index 8f7b389de8..558d6d9d36 100644
--- a/src/mongo/db/matcher/schema/expression_internal_schema_object_match.h
+++ b/src/mongo/db/matcher/schema/expression_internal_schema_object_match.h
@@ -38,7 +38,9 @@ public:
 
     InternalSchemaObjectMatchExpression(StringData path, std::unique_ptr<MatchExpression> expr);
 
-    bool matchesSingleElement(const BSONElement& elem, MatchDetails* details = nullptr) const final;
+    bool matchesSingleElement(const BSONElement& elem,
+                              ArrayPositionalMatch* details = nullptr,
+                              std::deque<std::string>* explain = nullptr) const final;
 
     std::unique_ptr<MatchExpression> shallowClone() const final;
 
diff --git a/src/mongo/db/matcher/schema/expression_internal_schema_root_doc_eq.cpp b/src/mongo/db/matcher/schema/expression_internal_schema_root_doc_eq.cpp
index 2684533c46..26a6ebb971 100644
--- a/src/mongo/db/matcher/schema/expression_internal_schema_root_doc_eq.cpp
+++ b/src/mongo/db/matcher/schema/expression_internal_schema_root_doc_eq.cpp
@@ -35,7 +35,8 @@ namespace mongo {
 constexpr StringData InternalSchemaRootDocEqMatchExpression::kName;
 
 bool InternalSchemaRootDocEqMatchExpression::matches(const MatchableDocument* doc,
-                                                     MatchDetails* details) const {
+                                                     ArrayPositionalMatch* details,
+                                                     std::deque<std::string>* explain) const {
     return _objCmp.evaluate(doc->toBSON() == _rhsObj);
 }
 
diff --git a/src/mongo/db/matcher/schema/expression_internal_schema_root_doc_eq.h b/src/mongo/db/matcher/schema/expression_internal_schema_root_doc_eq.h
index 7ca66e89ca..3710fc225c 100644
--- a/src/mongo/db/matcher/schema/expression_internal_schema_root_doc_eq.h
+++ b/src/mongo/db/matcher/schema/expression_internal_schema_root_doc_eq.h
@@ -51,14 +51,17 @@ public:
     explicit InternalSchemaRootDocEqMatchExpression(BSONObj rhs)
         : MatchExpression(MatchExpression::INTERNAL_SCHEMA_ROOT_DOC_EQ), _rhsObj(std::move(rhs)) {}
 
-    bool matches(const MatchableDocument* doc, MatchDetails* details = nullptr) const final;
+    bool matches(const MatchableDocument* doc,
+                 ArrayPositionalMatch* details = nullptr,
+                 std::deque<std::string>* explain = nullptr) const final;
 
     /**
      * This expression should only be used to match full documents, not objects within an array
      * in the case of $elemMatch.
      */
     bool matchesSingleElement(const BSONElement& elem,
-                              MatchDetails* details = nullptr) const final {
+                              ArrayPositionalMatch* details = nullptr,
+                              std::deque<std::string>* explain = nullptr) const final {
         MONGO_UNREACHABLE;
     }
 
diff --git a/src/mongo/db/matcher/schema/expression_internal_schema_str_length.h b/src/mongo/db/matcher/schema/expression_internal_schema_str_length.h
index 2a00de506b..5dca9ca632 100644
--- a/src/mongo/db/matcher/schema/expression_internal_schema_str_length.h
+++ b/src/mongo/db/matcher/schema/expression_internal_schema_str_length.h
@@ -48,7 +48,8 @@ public:
     virtual Validator getComparator() const = 0;
 
     bool matchesSingleElement(const BSONElement& elem,
-                              MatchDetails* details = nullptr) const final {
+                              ArrayPositionalMatch* details = nullptr,
+                              std::deque<std::string>* explain = nullptr) const final {
         if (elem.type() != BSONType::String) {
             return false;
         }
diff --git a/src/mongo/db/matcher/schema/expression_internal_schema_unique_items.h b/src/mongo/db/matcher/schema/expression_internal_schema_unique_items.h
index 5338d3fbcc..073272b3af 100644
--- a/src/mongo/db/matcher/schema/expression_internal_schema_unique_items.h
+++ b/src/mongo/db/matcher/schema/expression_internal_schema_unique_items.h
@@ -60,10 +60,19 @@ public:
         return nullptr;
     }
 
-    bool matchesArray(const BSONObj& array, MatchDetails*) const final {
+    bool matchesArray(const BSONObj& array,
+                      ArrayPositionalMatch*,
+                      std::deque<std::string>* explain) const final {
         auto set = _comparator.makeBSONEltSet();
-        for (auto&& elem : array) {
+        for (const auto& elem : array) {
             if (!std::get<bool>(set.insert(elem))) {
+                if (explain) {
+                    explain->push_front(
+                        str::stream()
+                        << "array does not have unique contents; duplicates of element with value "
+                        << elem.toString(false)
+                        << " exist");
+                }
                 return false;
             }
         }
diff --git a/src/mongo/db/matcher/schema/expression_internal_schema_xor.cpp b/src/mongo/db/matcher/schema/expression_internal_schema_xor.cpp
index 8a0d80c275..e719caab05 100644
--- a/src/mongo/db/matcher/schema/expression_internal_schema_xor.cpp
+++ b/src/mongo/db/matcher/schema/expression_internal_schema_xor.cpp
@@ -38,7 +38,8 @@ namespace mongo {
 constexpr StringData InternalSchemaXorMatchExpression::kName;
 
 bool InternalSchemaXorMatchExpression::matches(const MatchableDocument* doc,
-                                               MatchDetails* details) const {
+                                               ArrayPositionalMatch* details,
+                                               std::deque<std::string>* explain) const {
     bool found = false;
     for (size_t i = 0; i < numChildren(); i++) {
         if (getChild(i)->matches(doc, nullptr)) {
@@ -51,8 +52,10 @@ bool InternalSchemaXorMatchExpression::matches(const MatchableDocument* doc,
     return found;
 }
 
-bool InternalSchemaXorMatchExpression::matchesSingleElement(const BSONElement& element,
-                                                            MatchDetails* details) const {
+bool InternalSchemaXorMatchExpression::matchesSingleElement(
+    const BSONElement& element,
+    ArrayPositionalMatch* details,
+    std::deque<std::string>* explain) const {
     bool found = false;
     for (size_t i = 0; i < numChildren(); i++) {
         if (getChild(i)->matchesSingleElement(element, details)) {
diff --git a/src/mongo/db/matcher/schema/expression_internal_schema_xor.h b/src/mongo/db/matcher/schema/expression_internal_schema_xor.h
index e10ad9f315..c505235993 100644
--- a/src/mongo/db/matcher/schema/expression_internal_schema_xor.h
+++ b/src/mongo/db/matcher/schema/expression_internal_schema_xor.h
@@ -42,9 +42,13 @@ public:
 
     InternalSchemaXorMatchExpression() : ListOfMatchExpression(INTERNAL_SCHEMA_XOR) {}
 
-    bool matches(const MatchableDocument* doc, MatchDetails* details = nullptr) const final;
+    bool matches(const MatchableDocument* doc,
+                 ArrayPositionalMatch* details = nullptr,
+                 std::deque<std::string>* explain = nullptr) const final;
 
-    bool matchesSingleElement(const BSONElement&, MatchDetails* details = nullptr) const final;
+    bool matchesSingleElement(const BSONElement&,
+                              ArrayPositionalMatch* details = nullptr,
+                              std::deque<std::string>* explain = nullptr) const final;
 
     virtual std::unique_ptr<MatchExpression> shallowClone() const {
         auto xorCopy = stdx::make_unique<InternalSchemaXorMatchExpression>();
diff --git a/src/mongo/db/matcher/schema/expression_internal_schema_xor_test.cpp b/src/mongo/db/matcher/schema/expression_internal_schema_xor_test.cpp
index 0a982bfdba..f5d1055f34 100644
--- a/src/mongo/db/matcher/schema/expression_internal_schema_xor_test.cpp
+++ b/src/mongo/db/matcher/schema/expression_internal_schema_xor_test.cpp
@@ -83,17 +83,17 @@ TEST(InternalSchemaXorOp, DoesNotUseElemMatchKey) {
     BSONObj matchPredicate = fromjson("{$_internalSchemaXor: [{a: 1}, {b: 2}]}");
 
     auto expr = MatchExpressionParser::parse(matchPredicate, expCtx);
-    MatchDetails details;
-    details.requestElemMatchKey();
+    ArrayPositionalMatch details;
+    details.requestArrayPosition();
     ASSERT_OK(expr.getStatus());
     ASSERT_TRUE(expr.getValue()->matchesBSON(BSON("a" << 1), &details));
-    ASSERT_FALSE(details.hasElemMatchKey());
+    ASSERT_FALSE(details.arrayPosition());
     ASSERT_TRUE(expr.getValue()->matchesBSON(BSON("a" << BSON_ARRAY(1) << "b" << BSON_ARRAY(10)),
                                              &details));
-    ASSERT_FALSE(details.hasElemMatchKey());
+    ASSERT_FALSE(details.arrayPosition());
     ASSERT_FALSE(
         expr.getValue()->matchesBSON(BSON("a" << BSON_ARRAY(3) << "b" << BSON_ARRAY(4)), &details));
-    ASSERT_FALSE(details.hasElemMatchKey());
+    ASSERT_FALSE(details.arrayPosition());
 }
 
 TEST(InternalSchemaXorOp, Equivalent) {
diff --git a/src/mongo/db/query/get_executor.cpp b/src/mongo/db/query/get_executor.cpp
index 7238b4c2a4..eea8dada3b 100644
--- a/src/mongo/db/query/get_executor.cpp
+++ b/src/mongo/db/query/get_executor.cpp
@@ -718,9 +718,9 @@ StatusWith<unique_ptr<PlanStage>> applyProjection(OperationContext* opCtx,
     }
     unique_ptr<ParsedProjection> pp(rawParsedProj);
 
-    // ProjectionExec requires the MatchDetails from the query expression when the projection
-    // uses the positional operator. Since the query may no longer match the newly-updated
-    // document, we forbid this case.
+    // ProjectionExec requires the ArrayPositionalMatch from the query expression when the
+    // projection uses the positional operator. Since the query may no longer match the
+    // newly-updated document, we forbid this case.
     if (!allowPositional && pp->requiresMatchDetails()) {
         return {ErrorCodes::BadValue,
                 "cannot use a positional projection and return the new document"};
diff --git a/src/mongo/db/query/parsed_projection.cpp b/src/mongo/db/query/parsed_projection.cpp
index fa2b10f4f8..83622a4300 100644
--- a/src/mongo/db/query/parsed_projection.cpp
+++ b/src/mongo/db/query/parsed_projection.cpp
@@ -260,7 +260,7 @@ Status ParsedProjection::make(OperationContext* opCtx,
 
     pp->_isInclusionProjection = (includeExclude == IncludeExclude::kInclude);
 
-    // The positional operator uses the MatchDetails from the query
+    // The positional operator uses the ArrayPositionalMatch from the query
     // expression to know which array element was matched.
     pp->_requiresMatchDetails = arrayOpType == ARRAY_OP_POSITIONAL;
 
diff --git a/src/mongo/dbtests/matchertests.cpp b/src/mongo/dbtests/matchertests.cpp
index ee02b4b24d..1c8f8f9e36 100644
--- a/src/mongo/dbtests/matchertests.cpp
+++ b/src/mongo/dbtests/matchertests.cpp
@@ -203,20 +203,20 @@ public:
     }
 };
 
-/** Test that MatchDetails::elemMatchKey() is set correctly after a match. */
+/** Test that ArrayPositionalMatch::arrayPosition() is set correctly after a match. */
 template <typename M>
 class ElemMatchKey {
 public:
     void run() {
         boost::intrusive_ptr<ExpressionContextForTest> expCtx(new ExpressionContextForTest());
         M matcher(BSON("a.b" << 1), expCtx);
-        MatchDetails details;
-        details.requestElemMatchKey();
-        ASSERT(!details.hasElemMatchKey());
+        ArrayPositionalMatch details;
+        details.requestArrayPosition();
+        ASSERT(!details.arrayPosition());
         ASSERT(matcher.matches(fromjson("{ a:[ { b:1 } ] }"), &details));
         // The '0' entry of the 'a' array is matched.
-        ASSERT(details.hasElemMatchKey());
-        ASSERT_EQUALS(string("0"), details.elemMatchKey());
+        ASSERT(details.arrayPosition());
+        ASSERT_EQUALS(string("0"), *details.arrayPosition());
     }
 };
 
